#include "dmavif1.h"
#include "stitchhack.h"


bool bMustPushOnToTag;
uint32 uRecLastTagLoc;

// this file is a bit insane but has proven
// helpful quite a few times now.
// AddDouble and AddQuad can be done using calls to
// AddWord. It's very slow though and only intended
// for precreation of subdmachains.
void * InitChain(CDmaVif1 * pDmaVif1, uint32 uVifElem)
{	
	pDmaVif1->Reset();
	uint32 uCur = (uint32) pDmaVif1->GetCurLocation();
	assert((uCur&0xf)==0);
	uint32 uDst = (uCur&(~0xfff))+0x1000;
	pDmaVif1->AttachSrcNextTag((void *) uDst, uVifElem);
	uRecLastTagLoc = uCur;
	bMustPushOnToTag=true;
	return (void *) uCur;
}

void * AddWordToChain(CDmaVif1 * pDmaVif1, uint32 uVifElem)
{	
	void * pRet;
	
	if(bMustPushOnToTag)	// just had a tag, add second vifcode (tte based)
	{
		((uint32 *) uRecLastTagLoc)[3]=uVifElem;
		bMustPushOnToTag=false;
		pRet = (void *) &((uint32 *) uRecLastTagLoc)[3];
	}
	else
	{
		uint32 uCur = (uint32) pDmaVif1->GetCurLocation();
		if((uCur&0xfff)==0)	// stitch, reached page end
		{
			pDmaVif1->EndPacket();
			pDmaVif1->AttachSrcNextTag((void *) (uCur+0x1000), uVifElem);
			uRecLastTagLoc = uCur;
			pRet = (void *) &((uint32 *) uCur)[2];
			
			// hack
			bMustPushOnToTag=true;
		}
		else	// just add
		{
			pDmaVif1->add32(uVifElem);
			pRet = (void *) uCur;
		}
	}

	return pRet;
}

void Terminate(CDmaVif1 * pDmaVif1)
{
	if(bMustPushOnToTag)	// just had a tag, add second vifcode (tte based)
	{
		((uint32 *) uRecLastTagLoc)[3]=NOP;
		bMustPushOnToTag=false;
	}
	while(((uint32) pDmaVif1->GetCurLocation()&0xf)!=0)
		pDmaVif1->add32(NOP);
	pDmaVif1->EndPacket();
	uint64 uTag = ((uint64 *) uRecLastTagLoc)[0];
	uTag &= 0x8fffffffL;	// clear addr and ID
	uTag |= (6<<28);	// insert ret_tag ID
	((uint64 *) uRecLastTagLoc)[0] = uTag;
}

